> For the complete documentation index, see [llms.txt](https://docs.xorosoft.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xorosoft.com/developers-api/fulfillment-and-wave-management/fulfill-wave.md).

# Fulfill Wave

It is used to fulfill (pick) and close the wave lines by using request parameters.

| Field              | Data Type | Default Value | Description                                         |
| ------------------ | --------- | ------------- | --------------------------------------------------- |
| `WaveNumber`       | string    | NA            | Wave document number (may contain multiple orders). |
| `ItemNumber`       | string    | NA            | SKU number.                                         |
| `OrderNumber`      | string    | NA            | Order document number.                              |
| `PickLocationName` | string    | NA            | Warehouse 3PL location (Provided by the client).    |
| `QtyPicked`        | decimal   | 0             | Picked Quantity.                                    |

#### Equivalent Routes

This operation is documented once to avoid duplicate pages. The same workflow is also available at: `/api/xerp/wave/fullfill`.

```json
{"openapi":"3.0.3","info":{"title":"Xorosoft ERP Public API","version":"2026.07"},"tags":[{"name":"Fulfillment and Wave Management","description":"Use Fulfillment and Wave Management APIs to retrieve waves, create waves, fulfill waves, ship waves, confirm shipments, manage carriers and shipping terms, and support warehouse execution workflows. These APIs are designed for WMS, shipping, 3PL, and fulfillment integrations that need to move orders from allocation through picking, packing, shipping, and confirmation."}],"servers":[{"url":"https://res.xorosoft.io","description":"Xorosoft ERP API server"}],"security":[{"basic":[]}],"components":{"securitySchemes":{"basic":{"scheme":"basic","type":"http"}}},"paths":{"/api/xerp/wave/fulfill":{"post":{"responses":{"200":{"content":{"application/json":{"schema":{"properties":{"Data":{"properties":{"PreviewFlag":{"type":"boolean"},"WaveDetailAllocationArr":{"items":{"properties":{"BatchNumber":{"type":"number","nullable":true},"CreateSource":{"type":"string","nullable":true},"DestinationLocationBrcd":{"type":"string","nullable":true},"DestinationLocationId":{"type":"number"},"DestinationLocationName":{"type":"string","nullable":true},"Id":{"type":"number"},"ItemId":{"type":"number"},"ItemNumber":{"type":"string"},"ItemUpc":{"type":"string"},"LotNumber":{"type":"number","nullable":true},"LpnId":{"type":"number","nullable":true},"LpnNumber":{"type":"number","nullable":true},"MatchedFlag":{"type":"boolean"},"MfgDate":{"type":"string","nullable":true},"MoId":{"type":"number"},"MoLineId":{"type":"number"},"ModifyDttm":{"type":"string","nullable":true},"ModifySource":{"type":"string","nullable":true},"Note":{"type":"string","nullable":true},"OrderNumber":{"type":"string"},"PickLocationBrcd":{"type":"string","nullable":true},"PickLocationClassId":{"type":"number"},"PickLocationId":{"type":"number"},"PickLocationName":{"type":"string"},"PickSeq":{"type":"number","nullable":true},"PriorityNumber":{"type":"number","nullable":true},"QtyAllocated":{"type":"number"},"QtyDecimalFlag":{"type":"boolean"},"QtyPicked":{"type":"number"},"SoId":{"type":"number"},"SoLineId":{"type":"number"},"StatusId":{"type":"number"},"StatusName":{"type":"string","nullable":true},"StoreId":{"type":"number"},"WaveDetailId":{"type":"number"},"WaveId":{"type":"number"}},"type":"object"},"type":"array"},"WaveDetailArr":{"items":{"properties":{"BillToAddrName":{"type":"string","nullable":true},"CarrierId":{"type":"number"},"CloseFlag":{"type":"boolean"},"ConsolidationLocationId":{"type":"number","nullable":true},"CreateDate":{"type":"string"},"CreateDttm":{"type":"string"},"CreateSource":{"type":"string"},"CustomerName":{"type":"string"},"Freight":{"type":"number"},"Id":{"type":"number"},"IsCustomerOnHold":{"type":"boolean"},"ItemDescription":{"type":"string"},"ItemId":{"type":"number"},"ItemNumber":{"type":"string"},"ItemTypeId":{"type":"number"},"ItemTypeName":{"type":"string"},"ItemUpc":{"type":"string"},"KitItemShort":{"type":"boolean"},"MasterKitKey":{"type":"string","nullable":true},"MatchedFlag":{"type":"boolean"},"MoId":{"type":"number","nullable":true},"MoLineId":{"type":"number","nullable":true},"ModifyDttm":{"type":"string"},"ModifySource":{"type":"string"},"Note":{"type":"string"},"OrderNumber":{"type":"string"},"QtyAllocated":{"type":"number"},"QtyDecimalFlag":{"type":"boolean"},"QtyPicked":{"type":"number"},"QtyToPick":{"type":"number"},"RefNo":{"type":"string"},"SellUomId":{"type":"number"},"ShipFlag":{"type":"boolean"},"ShipMethodId":{"type":"number"},"ShipMethodName":{"type":"string"},"ShipServiceId":{"type":"number"},"ShipToAddrName":{"type":"string","nullable":true},"SoId":{"type":"number"},"SoLineId":{"type":"number"},"SoNumber":{"type":"number","nullable":true},"StatusId":{"type":"number"},"StatusName":{"type":"string"},"StoreId":{"type":"number"},"StoreName":{"type":"string"},"ThirdPartySource":{"type":"string"},"UnitPrice":{"type":"number"},"WaveDefaultLocationId":{"type":"number","nullable":true},"WaveDetailAllocationArr":{"type":"array","items":{"type":"object","additionalProperties":true},"nullable":true},"WaveId":{"type":"number"},"WaveNumber":{"type":"string"},"WaveStatusId":{"type":"number"},"WaveStatusName":{"type":"string","nullable":true},"WaveTypeId":{"type":"number"},"WaveTypeName":{"type":"string"}},"type":"object"},"type":"array"},"WaveHeaderData":{"properties":{"CloseWave":{"type":"boolean"},"CloseWaveByLinesOnly":{"type":"boolean"},"CreateDttm":{"type":"string"},"CreateSource":{"type":"string"},"Id":{"type":"number"},"LockFlag":{"type":"boolean"},"LockToggleFlag":{"type":"boolean"},"ModifyDttm":{"type":"string"},"ModifySource":{"type":"string"},"Note":{"type":"string"},"OrderWaveCount":{"type":"number"},"PlannedShipDate":{"type":"string"},"PriorityId":{"type":"number","nullable":true},"PriorityName":{"type":"string"},"StatusId":{"type":"number"},"StatusName":{"type":"string"},"StoreId":{"type":"number"},"StoreName":{"type":"string"},"TypeId":{"type":"number"},"TypeName":{"type":"string"},"UploadFlag":{"type":"boolean"},"WaveNumber":{"type":"string"}},"type":"object"}},"type":"object"},"IsForwardRequest":{"type":"boolean"},"Message":{"type":"string"},"MessageTitle":{"type":"string","nullable":true},"Result":{"type":"boolean"}},"type":"object"}}},"description":"OK","headers":{}}},"tags":["Fulfillment and Wave Management"],"description":"It is used to fulfill (pick) and close the wave lines by using request parameters.\nField               |Data Type          |Default Value          |Description\n-------------------|-------------------|-------------------|--------------\n``WaveNumber``|string|NA|Wave document number (may contain multiple orders).\n``ItemNumber``|string|NA|SKU number.\n``OrderNumber``|string|NA|Order document number.\n``PickLocationName ``|string|NA|Warehouse 3PL location (Provided by the client).\n``QtyPicked``|decimal|0|Picked Quantity.\n\n### Equivalent Routes\n\nThis operation is documented once to avoid duplicate pages. The same workflow is also available at: `/api/xerp/wave/fullfill`.","operationId":"post_wave_fulfill","requestBody":{"content":{"application/json":{"schema":{"properties":{"WaveDetailAllocationArr":{"items":{"properties":{"ItemNumber":{"type":"string"},"OrderNumber":{"type":"string"},"PickLocationName":{"type":"string"},"QtyPicked":{"type":"number"}},"type":"object"},"type":"array"},"WaveHeaderData":{"properties":{"WaveNumber":{"type":"string"}},"type":"object"}},"type":"object"}}}},"summary":"Fulfill Wave","parameters":[{"name":"autoFulfillNonInventory","in":"query","required":false,"description":"When true, non-inventory wave lines are automatically marked as fulfilled where supported.","schema":{"type":"boolean","default":false}},{"name":"batchWaveException","in":"query","required":false,"description":"When true, wave fulfillment exceptions are handled in batch mode.","schema":{"type":"boolean","default":true}}]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.xorosoft.com/developers-api/fulfillment-and-wave-management/fulfill-wave.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
